interface WritableSettings {
    tunnelSubdomain?: string;
}
type InstanceRole = 'unset' | 'leader' | 'follower';
export declare class InstanceSettings {
    private readonly userHome;
    readonly n8nFolder: string;
    readonly staticCacheDir: string;
    readonly customExtensionDir: string;
    readonly nodesDownloadDir: string;
    private readonly settingsFile;
    private settings;
    readonly instanceId: string;
    instanceRole: InstanceRole;
    get isLeader(): boolean;
    markAsLeader(): void;
    get isFollower(): boolean;
    markAsFollower(): void;
    get encryptionKey(): string;
    get tunnelSubdomain(): string | undefined;
    update(newSettings: WritableSettings): void;
    private getUserHome;
    private loadOrCreate;
    private generateInstanceId;
    private save;
}
export {};
